import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Spaceship here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Spaceship extends Actor
{

    GreenfootSound thrustSound = new GreenfootSound("thrust.wav");
    GreenfootSound shootSound = new GreenfootSound("EnergyGun.wav");
    final int GUN_RELOAD = 30;
    int gunCounter = 0;
    GreenfootImage ship = new GreenfootImage(30, 30); // 30x30 empty transparent image

    public Spaceship ()
    {
        drawShip();
    }
    
    /**
     * Act - do whatever the Spaceship wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        drawShip();
        checkForKeyboardEvents();
        checkForWorldEdge();
    }    
    
    public void drawShip()
    {
        GreenfootImage original = getImage();
        GreenfootImage image = new GreenfootImage(original.getWidth(), original.getHeight());
        int diameter = Greenfoot.getRandomNumber(30);
        int x = Greenfoot.getRandomNumber(image.getWidth());
        int y = Greenfoot.getRandomNumber(image.getHeight());
        int r = Greenfoot.getRandomNumber(256);
        int g = Greenfoot.getRandomNumber(256);
        int b = Greenfoot.getRandomNumber(256);        
        Color c = new Color(r, g, b);
        image.clear();
        image.setColor(c);
        image.setTransparency(128);
        image.fillOval(0, 0, diameter, diameter);
        image.drawLine(0, 0, 10, 10);
        image.drawLine(0, 0, 0, 10);
        image.drawLine(0, 0, 10, 0);        
        image.drawLine(10, 10, 0, 10);
        image.drawLine(10, 10, 10, 0);
        image.drawLine(10, 10, 10, 0);
        setImage(image);
        original.drawImage(image, 0, 0);
    }
    
    public void checkForKeyboardEvents()
    {
        if (Greenfoot.isKeyDown("up") )
        {
            setImage("rocketWithThrust.png");
            move(3);
            thrustSound.play();
        }
        else
        {
            setImage("rocket.png");
        }
        if (Greenfoot.isKeyDown("left") )
        {
            turn(-5);
        }
        if (Greenfoot.isKeyDown("right") )
        {
            turn(5);
        }
        if (Greenfoot.isKeyDown("space") )
        {
            if (gunCounter == 0)
            {
              getWorld().addObject(new Bullet(getRotation()), getX(), getY());
              shootSound.play();
              gunCounter = GUN_RELOAD;
            }
            else
            {
                gunCounter = gunCounter - 1;
            }
        }
        if (Greenfoot.isKeyDown("down") )
        {
            System.out.println("WIDTH: " + getImage().getWidth() + ", HEIGHT: " + getImage().getHeight());
        }        
    }
    
    public void checkForWorldEdge()
    {
        // off right hand side
        if ( getX() > getWorld().getWidth() - 5)
        {
            setLocation(5, getY());
        }
        // off left hand side
        if ( getX() < 5)
        {
            setLocation(getWorld().getWidth() - 5, getY());
        }
        // off botton
        if ( getY() > getWorld().getHeight() - 5)
        {
            setLocation(getX(), 5);
        }
        // off top
        if ( getY() < 5)
        {
            setLocation(getX(), getWorld().getHeight() - 5);
        }
        
    }
}
